'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _HeaderStyles = require('./HeaderStyles');

var _media = require('../../theme/media');

var _default = require('../../theme/default');

var _default2 = _interopRequireDefault(_default);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = function (_Component) {
	_inherits(Header, _Component);

	function Header(props) {
		_classCallCheck(this, Header);

		var _this = _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).call(this, props));

		_this.changeLogo = function (logo) {
			_this.setState({ logo: window.innerWidth >= _media.ScreenSizes.tablet ? logo.default : logo.smallLogo });
		};

		_this.componentWillUpdate = function (nextProps, nextState) {
			if (_this.props.logo !== nextProps.logo) _this.changeLogo(nextProps.logo);
		};

		_this.componentWillUnmount = function () {
			window.removeEventListener('resize', _this.changeLogo);
		};

		_this.renderNotification = function () {
			return _react2.default.createElement(
				'div',
				null,
				'NotiF'
			);
		};

		_this.renderAvatar = function () {
			return _react2.default.createElement(
				'div',
				null,
				'Avatar'
			);
		};

		_this.renderLogo = function (logo) {
			// console.log('renderLogo', logo)
			return _react2.default.createElement(
				_HeaderStyles.LogoDiv,
				{ to: '/' },
				_react2.default.createElement(_HeaderStyles.LogoImg, { src: logo })
			);
		};

		_this.renderSearchBar = function () {
			return _react2.default.createElement(
				'div',
				null,
				'Search'
			);
		};

		_this.state = {
			// logo: this.props.logo ? this.props.logo.default : this.props.logos ? this.props.logos[0] : theme.logo.default,
			// logos: theme.logo.bigLogo && theme.logo.smallLogo ? [theme.logo.bigLogo, theme.logo.smallLogo] : undefined
		};
		return _this;
	}

	_createClass(Header, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			if (this.props.logo !== undefined) {
				if (this.props.logo === 'default') this.changeLogo(_default2.default.logo);else this.changeLogo(this.props.logo);
				window.addEventListener('resize', this.changeLogo);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			// console.log(this.props.logo)
			var _props = this.props,
			    search = _props.search,
			    notification = _props.notification,
			    avatar = _props.avatar;
			var logo = this.state.logo;
			var renderLogo = this.renderLogo,
			    renderSearchBar = this.renderSearchBar,
			    renderAvatar = this.renderAvatar,
			    renderNotification = this.renderNotification;

			return _react2.default.createElement(
				_HeaderStyles.HeaderDiv,
				null,
				logo && renderLogo(logo),
				search && renderSearchBar(),
				avatar && renderAvatar(),
				notification && renderNotification()
			);
		}
	}]);

	return Header;
}(_react.Component);

Header.propTypes = {
	logo: _propTypes2.default.object,
	search: _propTypes2.default.bool,
	notification: _propTypes2.default.bool,
	avatar: _propTypes2.default.bool
};

Header.defaultProps = {
	search: false,
	notification: false,
	avatar: false
};

exports.default = Header;