'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _TabStyles = require('../Tabs/TabStyles');

var _Tab = require('../Tabs/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Workspace = require('../Workspace/Workspace');

var _Workspace2 = _interopRequireDefault(_Workspace);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Menu = function (_Component) {
	_inherits(Menu, _Component);

	function Menu() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Menu);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Menu.__proto__ || Object.getPrototypeOf(Menu)).call.apply(_ref, [this].concat(args))), _this), _this.route = function (child) {
			return _this.props.route ? _this.props.route : _this.convertLabelToRoute(_this.props.label);
		}, _this.convertLabelToRoute = function (label) {
			var route = label.replace(/\s+/g, '-').toLowerCase();
			route = '/' + route;
			return route;
		}, _this.childRoute = function (child) {
			return child.props.route ? child.props.route : _this.convertLabelToRoute(child.props.label);
		}, _this.renderChildren = function (children) {
			return children.map(function (child, index) {
				return _react2.default.createElement(_reactRouterDom.Route, { key: index, path: _this.route() + _this.childRoute(child), component: _this.renderChild(child) });
			});
		}, _this.renderChild = function (child) {
			return function () {
				return _react2.default.createElement(
					_Workspace2.default,
					null,
					child.props.children
				);
			};
		}, _this.renderTabs = function (children) {
			if (children[0].type === _Tab2.default) return _react2.default.createElement(
				_TabStyles.SceneDiv,
				null,
				_react2.default.createElement(
					_TabStyles.TabList,
					null,
					children.map(function (child, index) {
						return _react2.default.createElement(_Tab2.default, { key: index,
							helpID: child.props.helpID,
							active: window.location.pathname.includes(_this.childRoute(child)) ? true : false,
							label: child.props.label,
							icon: child.props.icon,
							route: _this.route() + _this.childRoute(child) });
					})
				),
				_react2.default.createElement(
					_reactRouterDom.Switch,
					null,
					_this.renderChildren(children)
				)
			);else return _react2.default.createElement(
				_TabStyles.SceneDiv,
				null,
				_this.renderNoTabs(children)
			);
		}, _this.renderNoTabs = function (children) {
			return _react2.default.createElement(
				_Workspace2.default,
				null,
				children
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	//#region Label Converting for Menu


	//#endregion

	//#region RenderChildren

	//#endregion

	_createClass(Menu, [{
		key: 'render',
		value: function render() {
			var Children = [];
			Array.isArray(this.props.children) ? Children.push.apply(Children, _toConsumableArray(this.props.children)) : Children.push(this.props.children);
			return this.renderTabs(Children);
		}
	}]);

	return Menu;
}(_react.Component);

Menu.propTypes = {
	label: _propTypes2.default.string,
	route: _propTypes2.default.string,
	icon: _propTypes2.default.string
};

exports.default = Menu;