'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MenuStyles = require('../MenuStyles');

var _odeumUi = require('odeum-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuDiv = function (_Component) {
	_inherits(MenuDiv, _Component);

	function MenuDiv(props) {
		_classCallCheck(this, MenuDiv);

		var _this = _possibleConstructorReturn(this, (MenuDiv.__proto__ || Object.getPrototypeOf(MenuDiv)).call(this, props));

		_this.sizes = {
			giant: 1170,
			desktop: 992,
			tablet: 768,
			phone: 376
		};

		_this.updateWindowDimensions = function () {
			if (window.innerWidth < _this.sizes.tablet && !_this.state.disableAchordeon) {
				_this.setState({ achordeon: false, disableMenuAchordeon: true });
			} else if (window.innerWidth >= _this.sizes.tablet && _this.state.disableMenuAchordeon) {
				_this.setState({ disableAchordeon: false });
			}
		};

		_this.switch = function () {
			return _this.setState({ achordeon: !_this.state.achordeon });
		};

		_this.state = {
			achordeon: true,
			disableAchordeon: false
		};
		return _this;
	}

	_createClass(MenuDiv, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.updateWindowDimensions();
			window.addEventListener('resize', this.updateWindowDimensions);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			window.removeEventListener('resize', this.updateWindowDimensions);
		}
	}, {
		key: 'render',
		value: function render() {
			var disableAchordeon = this.state.disableAchordeon;

			return _react2.default.createElement(
				_MenuStyles.MenuDiv,
				{ achordeon: this.state.achordeon },
				_react2.default.createElement(
					_MenuStyles.MenuHeader,
					null,
					_react2.default.createElement(
						_MenuStyles.IconDiv,
						{ onClick: !disableAchordeon ? this.switch : null,
							style: { cursor: 'pointer' } },
						_react2.default.createElement(_odeumUi.Icon, { icon: 'menu', iconSize: 20, color: 'white', style: { marginRight: '0px' } })
					)
				),
				this.props.children
			);
		}
	}]);

	return MenuDiv;
}(_react.Component);

exports.default = MenuDiv;