'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _MenuItem = require('./MenuComponents/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _MenuDiv = require('./MenuComponents/MenuDiv');

var _MenuDiv2 = _interopRequireDefault(_MenuDiv);

var _MenuStyles = require('./MenuStyles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuPanel = function (_Component) {
	_inherits(MenuPanel, _Component);

	function MenuPanel(props) {
		_classCallCheck(this, MenuPanel);

		var _this = _possibleConstructorReturn(this, (MenuPanel.__proto__ || Object.getPrototypeOf(MenuPanel)).call(this, props));

		_this.route = function (child) {
			return child.props.route ? child.props.route : _this.convertLabelToRoute(child.props.label);
		};

		_this.convertLabelToRoute = function (label) {
			var route = '/' + label.replace(/\s+/g, '-').toLowerCase();
			return route;
		};

		_this.getFirstChildRoute = function (child) {
			if (Array.isArray(child.props.children)) {
				if (child.props.children[0].props.route) return child.props.children[0].props.route;else return _this.convertChildLabelToRoute(child, true);
			} else if (child.props.children.props.route) {
				return child.props.children.props.route;
			} else return _this.convertChildLabelToRoute(child, false);
		};

		_this.convertChildLabelToRoute = function (child, many) {
			var route = '';
			if (many === true) {
				if (child.props.children[0].props.label) route = '/' + child.props.children[0].props.label.replace(/\s+/g, '-').toLowerCase();
			} else if (child.props.children.props.label) route = '/' + child.props.children.props.label.replace(/\s+/g, '-').toLowerCase();
			return route;
		};

		_this.switch = function () {
			return _this.setState({ achordeon: !_this.state.achordeon });
		};

		_this.setActiveMenu = function (key) {
			_this.setState({ activeMenu: key });
		};

		_this.renderChild = function (child) {
			return function (_ref) {
				var match = _ref.match;
				return child;
			};
		};

		_this.renderMenu = function (children) {
			return _react2.default.createElement(
				_MenuStyles.MenuContainer,
				null,
				_react2.default.createElement(
					_MenuDiv2.default,
					null,
					children.map(function (child, index) {
						return child.props.label ? _react2.default.createElement(_MenuItem2.default, { key: index,
							MenuID: index,
							helpID: child.props.helpID,
							active: _this.state.activeMenu === index ? true : false,
							icon: child.props.icon,
							label: child.props.label,
							route: _this.route(child) + _this.getFirstChildRoute(child),
							onClick: _this.setActiveMenu }) : null;
					})
				),
				_react2.default.createElement(
					_reactRouterDom.Switch,
					null,
					children.map(function (child, i) {
						return _react2.default.createElement(_reactRouterDom.Route, { key: i, path: _this.route(child), exact: child.props.exact ? child.props.exact : undefined, route: _this.route(child), component: _this.renderChild(child) });
					})
				)
			);
		};

		_this.state = {
			achordeon: true,
			disableMenuAchordeon: false,
			activeMenu: 0
		};
		return _this;
	}
	//#region Label Converting for Menu

	//#endregion

	//#region Tabs Routing + Get First Tab Route 

	//#endregion

	//#region State Management

	//#endregion

	//#region Rendering

	_createClass(MenuPanel, [{
		key: 'render',
		value: function render() {
			var Children = [];
			Array.isArray(this.props.children) ? Children.push.apply(Children, _toConsumableArray(this.props.children)) : Children.push(this.props.children);
			return this.renderMenu(Children);
		}

		//#endregion

	}]);

	return MenuPanel;
}(_react.Component);

exports.default = MenuPanel;